%define api 7
%define major 7
%define plusmaj %{major}
%define libname %mklibname %{name} %{api} %{major}
%define libplus %mklibname mlt++ %{api} %{plusmaj}
%define devname %mklibname %{name} -d
%define _disable_lto 1
##################################################
#
# rename /usr/lib64/pkgconfig/movit.pc then build then rename it back !!!
#
##################################################

Summary:	Media Lovin' Toolkit nonlinear video editing library
Name:		mlt
Version:	7.23.0
Release:	%mkrel 2
License:	LGPLv2+
Group:		Video
Url:		http://mltframework.org/
Source0:	https://github.com/mltframework/mlt/releases/download/v%{version}/%{name}-%{version}.tar.xz

BuildRequires:	cmake
BuildRequires:	imagemagick
BuildRequires:	ffmpeg
BuildRequires:	ffmpeg-devel
BuildRequires:	ladspa-devel
BuildRequires:	node-js
BuildRequires:	pkgconfig(Qt5Core)
BuildRequires:	pkgconfig(Qt5Gui)
BuildRequires:	pkgconfig(Qt5OpenGL)
BuildRequires:	pkgconfig(Qt5Svg)
BuildRequires:	pkgconfig(Qt5Widgets)
BuildRequires:	pkgconfig(Qt5Xml)
BuildRequires:	pkgconfig(alsa)
BuildRequires:	pkgconfig(libexif)
BuildRequires:	pkgconfig(eigen3)
BuildRequires:	pkgconfig(fftw3)
BuildRequires:	pkgconfig(epoxy)
BuildRequires:	pkgconfig(gl)
BuildRequires:	pkgconfig(frei0r)
BuildRequires:	pkgconfig(glib-2.0)
BuildRequires:	pkgconfig(gtk+-2.0)
BuildRequires:	pkgconfig(jack)
BuildRequires:	pkgconfig(libdv)
BuildRequires:	pkgconfig(libquicktime)
BuildRequires:	pkgconfig(libpulse)
BuildRequires:	pkgconfig(libxml-2.0)
BuildRequires:	pkgconfig(mad)
BuildRequires:	pkgconfig(movit)
BuildRequires:	pkgconfig(ogg)
BuildRequires:	pkgconfig(pango)
BuildRequires:	pkgconfig(rubberband)
BuildRequires:	pkgconfig(samplerate)
BuildRequires:	pkgconfig(sdl2)
BuildRequires:	pkgconfig(sox)
BuildRequires:	pkgconfig(vorbis)
BuildRequires:	pkgconfig(opencv4)
BuildRequires:	cmake ninja
# For python-bindings
BuildRequires:	swig
BuildRequires:	pkgconfig(python3)
# For ruby bindings
BuildRequires:	ruby-devel

Obsoletes: mlt-kdenlive

%description
MLT is an open source multimedia framework, designed and developed for
television broadcasting.

It provides a toolkit for broadcasters, video editors, media players,
transcoders, web streamers and many more types of applications. The
functionality of the system is provided via an assortment of ready to
use tools, xml authoring components, and an extendible plug-in based
API.

%files
%{_bindir}/melt
%{_bindir}/melt-%{api}
%{_datadir}/mlt-%{api}
%{_libdir}/mlt-%{api}
%{_mandir}/man1/melt.1*
%{_mandir}/man1/melt-%{api}.1*

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	Main library for mlt
Group:		System/Libraries

Obsoletes:	%{_lib}mlt7 < %{version}

%description -n %{libname}
This package contains the libraries needed to run programs dynamically
linked with mlt.

%files -n %{libname}
%{_libdir}/libmlt-%{major}.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{libplus}
Summary:	Main library for mlt++
Group:		System/Libraries

Obsoletes:	%{_lib}mlt++7 < %{version}

%description -n %{libplus}
This package contains the libraries needed to run programs dynamically
linked with mlt++.

%files -n %{libplus}
%{_libdir}/libmlt++-%{api}.so.%{plusmaj}*
%if "%{plusmaj}" != "%{major}"
%{_libdir}/libmlt++-%{api}.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Headers for developing programs that will use mlt
Group:		Development/Libraries
Requires:	%{libname}
Requires:	%{libplus}
Requires:	%{name}
Provides:	%{name}-devel

%description -n %{devname}
This package contains the headers that programmers will need to develop
applications which will use mlt.

%files -n %{devname}
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc
%{_libdir}/cmake/Mlt%{api}

#----------------------------------------------------------------------------

%package -n python3-%{name}
Summary:	Python bindings for MLT
Group:		Development/Python
Requires:	python3
Requires:	%{name}
Obsoletes: python-mlt

%description -n python3-%{name}
This module allows to work with MLT using python.

%files -n python3-%{name}
%{python3_sitearch}/*

#----------------------------------------------------------------------------

%package -n ruby-%{name}
Summary:	Ruby bindings for MLT
Group:		Development/Ruby
Requires:	ruby
Requires:	%{name}

%description -n ruby-%{name}
This module allows to work with MLT using ruby.

%files -n ruby-%{name}
%{_libdir}/ruby/vendor_ruby/mlt.so

#----------------------------------------------------------------------------

%prep
%setup -qn %{name}-%{version}
%autopatch -p1

%build
# from tex
CFLAGS+=' -fcommon'
export LDFLAGS="-L/usr/lib64/libglvnd/ $LDFLAGS"

%cmake -DGPL:BOOL=ON \
	-DGPL3:BOOL=ON \
	-DMOD_OPENCV:BOOL=ON \
	-DMOD_OPENGL:BOOL=ON \
	-DSWIG_PYTHON:BOOL=ON \
	-DSWIG_RUBY:BOOL=ON \
	-DMOD_MOVIT:BOOL=ON

%cmake_build

%install
rm -rf %{buildroot}
%cmake_install

#man page
install -Dpm644 docs/melt.1 %{buildroot}%{_mandir}/man1/melt.1

#compatibility links
ln -fs %{_libdir}/pkgconfig/mlt++-7.pc %buildroot/%{_libdir}/pkgconfig/mlt++.pc
ln -fs %{_libdir}/pkgconfig/mlt-framework-7.pc %buildroot/%{_libdir}/pkgconfig/mlt-framework.pc

%clean
rm -rf %{buildroot}

%post
/sbin/ldconfig


%changelog
* Sun Feb 11 2024 onkelho <oh.quait at gmail.com> - 7.23.0-2quait2024
- rebuild
- add 16 fixes

* Wed Jan 10 2024 onkelho <oh.quait at gmail.com> - 7.23.0-1quait2024
- new version interim
- all from 7.22.0 + fixes
 
* Fri Jul 29 2022 onkelho <oh.quait at gmail.com> - 7.9.0-1pclos2022
- new version release

* Fri Jul 29 2022 onkelho <oh.quait at gmail.com> - 7.8.0-10pclos2022
- new version release

* Tue Dec 21 2021 onkelho <oh.quait at gmail.com> - 7.4.0-2pclos2022
- rebuild against fixed movit.pc

* Tue Dec 21 2021 onkelho <oh.quait at gmail.com> - 7.4.0-1pclos2022
- new version release

* Thu Aug 12 2021 tex - 7.0.1-1pclos2021
- new version for KDENLIVE
